FUNCTION SINALT#(sm%, MJDO#, Hour#, lambda#, cphi#, sphi#)
 MJD# = MJDO# + Hour# / 24
 t# = (MJD# - 51544.5) / 36525
 IF sm% = 1 THEN CALL MiniSun(t#, ra#, dec#) ELSE CALL MiniMoon(t#, ra#, dec#)
 tau# = 15 * (LMST#(MJD#, lambda#) - ra#)
 SINALT# = sphi# * SN(dec#) + cphi# * CS#(dec#) * CS#(tau#)
END FUNCTION

FUNCTION SN#(x#)
 SN# = SIN(x# * .0174532925199433#)
END FUNCTION

FUNCTION FRAK#(x#)
 x# = x# - FIX(x#)
 IF x# < 0 THEN x# = x# + 1
 FRAK# = x#
END FUNCTION

FUNCTION ART#(x#)
 ART# = ATN(x#) / .0174532925199433#
END FUNCTION

FUNCTION ASN#(x#)
 IF ABS(x#) = 1 THEN ASN# = 90 * x#: EXIT FUNCTION
 IF ABS(x#) > .0000001 THEN
   ASN# = ATN(x# / SQR((1 - x#) * (1 + x#))) / .0174532925199433#
 ELSE
   ASN# = x# / .0174532925199433#
 END IF
END FUNCTION

FUNCTION TGN#(x#)
 TGN# = TAN(x# * .0174532925199433#)
END FUNCTION

FUNCTION Kreis#(x#)
 IF x# < 0 THEN
   Kreis# = 360 - (ABS(x#) - INT(ABS(x#) / 360) * 360)
 ELSE
   Kreis# = x# - INT(x# / 360) * 360
 END IF
END FUNCTION

FUNCTION LMST#(MJD#, lambda#)
 MJDO# = INT(MJD#)
 ut# = (MJD# - MJDO#) * 24
 t# = (MJDO# - 51544.5) / 36525
 gmst# = 6.697374558# + 1.0027379093# * ut# + (8640184.812866# + (.093104 - .0000062# * t#) * t#) * t# / 3600
 LMST# = 24 * FRAK#((gmst# - lambda# / 15) / 24)
END FUNCTION

FUNCTION CS#(x#)
 CS# = COS(x# * .0174532925199433#)
END FUNCTION

FUNCTION asin#(x#)
  IF x# = 0 THEN
    asin# = 0
  ELSE
    asin# = ATN(x# / SQR(1 - x# * x#))
  END IF
END FUNCTION

FUNCTION atn2#(y#, x#)
  pi# = 3.141592653589793#
  IF x# = 0 AND y# = 0 THEN
    Tmp# = 0
  ELSE
    IF ABS(x#) > ABS(y#) THEN
      Tmp# = ATN(y# / x#)
      IF x# < 0 THEN
        IF Tmp# < 0 THEN
          Tmp# = Tmp# + pi#
        ELSE
          Tmp# = Tmp# - pi#
        END IF
      END IF
    ELSE
      Tmp# = pi# / 2 - ATN(x# / y#)
      IF y# < 0 THEN Tmp# = Tmp# - pi#
    END IF
  END IF
  atn2# = Tmp#
END FUNCTION
